summaryrefslogtreecommitdiff
path: root/tests.merging/rename-chunk.script
diff options
context:
space:
mode:
authorSam Thursfield <sam.thursfield@codethink.co.uk>2012-10-29 16:02:42 +0000
committerSam Thursfield <sam.thursfield@codethink.co.uk>2012-10-29 18:19:26 +0000
commit1342bf9006f28a08d1b32dc8218717ebda701dc2 (patch)
tree0872d902b6ad4af6c4e238a28bc0c01624c62e0b /tests.merging/rename-chunk.script
parent9e4159ba97862c78a9cfa3e3816f18c708ccba5e (diff)
downloadmorph-1342bf9006f28a08d1b32dc8218717ebda701dc2.tar.gz
Split merge tests out from the other branching tests
Merge is by far the most complex of the branching and merging commands.
Diffstat (limited to 'tests.merging/rename-chunk.script')
-rwxr-xr-xtests.merging/rename-chunk.script62
1 files changed, 62 insertions, 0 deletions
diff --git a/tests.merging/rename-chunk.script b/tests.merging/rename-chunk.script
new file mode 100755
index 00000000..06969b70
--- /dev/null
+++ b/tests.merging/rename-chunk.script
@@ -0,0 +1,62 @@
+#!/bin/sh
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# "morph merge" should pull changes from a chunk even if its name was changed
+# in the branch
+
+set -eu
+
+# Disable test on versions of Python before 2.7.
+if ! python --version 2>&1 | grep '^Python 2\.[78]' > /dev/null
+then
+ exit 0
+fi
+
+# Create system branch.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" init
+"$SRCDIR/scripts/test-morph" branch baserock:morphs baserock/newbranch
+
+# Rename the chunk, and then commit a seperate change
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum hello
+cd baserock/newbranch/baserock:hello
+
+cat hello.morph | sed -e 's/"name": "hello"/"name": "goodbye"/' > goodbye.morph
+git rm -q hello.morph
+git add goodbye.morph
+git commit -m "Rename chunk" --quiet
+
+touch newfile.txt
+git add newfile.txt
+git commit -m "Add new file" --quiet
+
+# Update stratum to point at the renamed chunk
+cd ../baserock:morphs
+sed -ie 's/"name": "hello"/"name": "goodbye"/' hello-stratum.morph
+git commit --all --quiet -m "Update morph refs for baserock/newbranch"
+
+# Merge changes back to master
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" checkout baserock:morphs master
+cd master
+"$SRCDIR/scripts/test-morph" merge baserock/newbranch
+
+# Morph should have realised that 'goodbye' is not a new chunk,
+# and pulled in the changes from 'hello' in the old branch
+cd baserock:hello
+[ ! -e hello.morph ]
+[ -e goodbye.morph ]
+[ -e newfile.txt ]